unit iModule;

interface

uses
    Windows;

function   PrintModule(AWindowHandle: HWND): string;

implementation

uses
    psapi;

(*
    ===========================================================================
    vZXIDɊ֌W郂W[tpX
    ---------------------------------------------------------------------------
    XP, 2003, 2000(Pro/Svr), NT(WS/Svr) 
    ---------------------------------------------------------------------------
    ms-help://MS.PSDK.1033/perfmon/base/enumerating_all_modules_for_a_process.htm
    ===========================================================================
*)
function   PrintModule(AWindowHandle: HWND): string;
const
    MAX_HMODULE = 1024;
var
    ProcessID : integer;
    DesiredAccess: Cardinal;                        //  tO
    ModHandle : array[0..MAX_HMODULE-1] of HMODULE; //  W[nh
    ProcHandle: THandle;                            //  vZXnh
    cbNeeded  : DWORD;                              //  z̑傫
    i         : integer;
    p         : PChar;
    ModNameLen: integer;                            //  W[
    ModName   : string;                             //  W[
begin
    Result := 'Unknown';
    //  EBhEnhɑΉvZXIDo
    GetWindowThreadProcessId(AWindowHandle, @ProcessID);
    //  vZX̃nho
    DesiredAccess := PROCESS_QUERY_INFORMATION or PROCESS_VM_READ;
    ProcHandle := OpenProcess(DesiredAccess, false, ProcessID);
    //  sH
    if (ProcHandle = INVALID_HANDLE_VALUE) then
    begin
        Exit;
    end
    //  I
    else
    begin
        try
            //  ̃vZX̑SẴW[̃Xg擾(pspi.dll)
            if (EnumProcessModules(ProcHandle, @ModHandle, MAX_HMODULE, cbNeeded)) then
            begin
                //  W[̌JԂ܂傤
                for i := 0 to (cbNeeded div sizeof(HMODULE)) - 1 do
                begin
                    //  m
                    GetMem(p, MAX_PATH);
                    //  W[t@C̃tpX擾
                    ModNameLen := GetModuleFileNameEx(ProcHandle, ModHandle[i], p, MAX_PATH);
                    //  
                    SetString(ModName, p, ModNameLen);
                    //  
                    FreeMem(p);
                    //  Xgɒǉ
                    Result := ModName;
                    break;
                end;
            end;
        finally
            //  J߂
            CloseHandle(ProcHandle);
        end;
    end;
end;

end.

