(*
    ===========================================================================
    AvP[V̑L^
    ---------------------------------------------------------------------------
    http://hp.vector.co.jp/authors/VA003525/Jindex.htm
    ---------------------------------------------------------------------------
    Đ͕KvȂ̂őSč폜
    ===========================================================================
*)

unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, AppEvnts;

type
    TMainForm = class(TForm)
        Memo1: TMemo;
        Panel1: TPanel;
    BtnInstall: TButton;
    BtnUnInstall: TButton;
    ChkIgnore: TCheckBox;
        procedure BtnInstallClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BtnUnInstallClick(Sender: TObject);
    procedure ChkIgnoreClick(Sender: TObject);
    private

    public

    end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

uses
    iMessage, iModule;

var
    JournalHook: Integer;
    IgnoreMouseMove: Boolean = false;

(*
    in Windows.pas
type
    //  JournalingŎgp郁bZ[W\
    PEventMsg = ^TEventMsg;
    tagEVENTMSG = packed record
        message : UINT;
        paramL  : UINT;
        paramH  : UINT;
        time    : DWORD;
        hwnd    : HWND;
    end;
    TEventMsg = tagEVENTMSG;
*)


(*
    ===========================================================================
    L^ACxgɌĂяo
    ---------------------------------------------------------------------------
    The return value is ignored.
    ---------------------------------------------------------------------------
    http://hp.vector.co.jp/authors/VA003525/Jindex.htm
    ms-help://MS.PSDK.1033/winui/winui/windowsuserinterface/windowing/hooks/
                           hookreference/hookfunctions/journalrecordproc.htm
    ===========================================================================
*)
function    JournalRecordProc(nCode: Integer; wParam: WPARAM; pEvnt: PEventMsg): LRESULT; stdcall;
//var
//    pMes: PEventMsg;
var
    Time: Cardinal;
    WH: HWND;
    MsgName: string;
    DebugStr: string;
begin
    //  nCode < 0 ̎́ACallNextHookExĂ
    //  ŁA߂lCallNextHookEx̖߂l߂ׂ
    if nCode < 0 then
    begin
        Result := CallNextHookEx(JournalHook, nCode, wParam, Longint(pEvnt))
    end
    else
    begin
        Result := 0;

        case nCode of

        //  The lParam parameter is a pointer to an EVENTMSG structure containing
        //  information about a message removed from the system queue.
        //   The hook procedure must record the contents of the structure
        //  by copying them to a buffer or file.
        HC_ACTION:
            begin
                if (IgnoreMouseMove) and (pEvnt^.Message = WM_MOUSEMOVE) then
                begin
                    Exit;
                end;

                //  Ԏo
                Time := pEvnt^.time;
                //  bZ[WMEBhEnho
                WH := pEvnt^.hwnd;
                //  bZ[WoE̕ϊ
                MsgName := GetMessageName(pEvnt^.Message);
                //  o͕
                DebugStr := Format('%-20s %5d %5d %s %s', [MsgName, pEvnt^.paramL, pEvnt^.paramH, PrintModule(WH), DebugStr]);
                //  o
                MainForm.Memo1.Lines.Add(DebugStr);
            end;

        HC_SYSMODALON : ;
        HC_SYSMODALOFF: ;

        end;

    end;
end;

(*
    ---------------------------------------------------------------------------
    CXg[
    ---------------------------------------------------------------------------
*)
procedure InstallHook();
begin
    JournalHook := SetWindowsHookEx(WH_JOURNALRECORD, @JournalRecordProc, hInstance, 0);
    Application.MainForm.Caption := 'tbN...';
end;

(*
    ---------------------------------------------------------------------------
    ACXg[
    ---------------------------------------------------------------------------
*)
procedure UnInstallHook();
begin
    if JournalHook <> 0 then
    begin
        UnhookWindowsHookEx(JournalHook);
        JournalHook := 0;
    end;
    Application.MainForm.Caption := 'tbNĂ܂B';
end;

(*
    ===========================================================================
    WM_MOUSEMOVE H
    ===========================================================================
*)
procedure TMainForm.ChkIgnoreClick(Sender: TObject);
begin
    IgnoreMouseMove := ChkIgnore.Checked;
end;

(*
    ===========================================================================
    CXg[
    ===========================================================================
*)
procedure TMainForm.BtnInstallClick(Sender: TObject);
begin
    InstallHook();
end;

(*
    ===========================================================================
    ACXg[
    ===========================================================================
*)
procedure TMainForm.BtnUnInstallClick(Sender: TObject);
begin
    UnInstallHook();
end;

(*
    ===========================================================================
    fXgN^
    ===========================================================================
*)
procedure TMainForm.FormDestroy(Sender: TObject);
begin
    UnInstallHook();
end;

end.

